
import java.util.*;

public class  NodeManagerImpl extends java.rmi.server.UnicastRemoteObject implements NodeManager{

	private LinkedList l = new LinkedList();//list of know victim
	private Random r = new Random();

	public NodeManagerImpl()  throws java.rmi.RemoteException{
		super();
	}

	public synchronized void publishVictim(ThiefVictimAgent tva) throws java.rmi.RemoteException{
	//receive a new Thief-Victim-Agent stub and store it
		l.add(tva);
	}

	public synchronized ThiefVictimAgent choseVictim(ThiefVictimAgent tva) throws java.rmi.RemoteException{
	//return a Victim randomicaly choosed

		if(l.size()==0)
			return null;
		int i = r.nextInt(l.size());
		ThiefVictimAgent victim = (ThiefVictimAgent) l.get(i);
		if (victim.equals(tva)){ //if victim is the same, gets another victim
			victim = (ThiefVictimAgent) l.get((i+1)%l.size());
			if (tva.equals(victim)){
				return null;//there is only the thief itself on the list
			}
		}
		return victim;
	}
}
