
import java.util.*;

public class TaskManager{
	private LinkedList l = new LinkedList();//circular list of Tasks
	private int pointer; //next task to be stolen

	public TaskManager(){
		pointer=0;
	}

	public synchronized void insertTask(Task t){
	//insert a new task at the end of the list
		l.add(t);
	}

	public synchronized Task getTask(Who who){
	//return a task from the circular list with work !!!
	if (l.size() == 0)
		return null; //empty list
	else{
		int count = 0;
		do{ //find a task with work to do
			Task t1 = (Task) l.get(pointer++ % l.size()); //t1 points to a lazy task
			Task t2 = (Task) t1.clone(); //t2 is a copy of the task t1
			//get work for it
			TaskEater te = t1.getFather();
			Object obj = ((TaskEaterImpl) te).getWork(new Who(t1.getID(),who.elapsedTime,who.timeGoal,who.param));
			if (obj!= null) { //there are work!
				Interval inter = t1.getInterval();
				t2.setID(inter.begin,inter.limit);
				t2.setFather(te);//set father
				t2.setFatherID(t1.getFatherID());
				t2.setTimeGoal(t1.getTimeGoal());
				t2.initTask(obj);
				try{
					WorkCriteria wc = (WorkCriteria) (t1.getWorkCriteria()).clone();
					t2.setWorkCriteria(wc);
				}catch(CloneNotSupportedException e){
					System.out.println("Unable to clone Task's WorkCriteria :" + e);
				}
				inter = ((TaskEaterImpl) te).getNewInterval();
				t1.setID(inter.begin,inter.limit); //new name
				return t2;
			}
			count++;
		}while(count < l.size());
		//couldn't find a task with work
		return null;
	}
	}

	public synchronized void clearSon(long ID){
	//remove the son of the Task "t"
		long fatherID;

		for(int i=0;i<l.size();i++){
			fatherID = ((Task) l.get(i)).getFatherID();
			if (fatherID == ID){//son found
				l.remove(i);
				break;
			}
		}
	}
}
