package org.isam.exehda.services.dhc.client;

import org.isam.exehda.services.dhc.*;
import java.io.*;

/*
 * KConfHostDeamon.java Creates a process that will listen for host 
 * query messages and respond with the given host address
 */

public class KConfHostDeamon extends Thread{
    public static void main(String[] args){
	try{
	    File file = new File("KConf.Host");
	    //if KConf.Host exists launch the process
	    if(file.exists()){
		BufferedReader br = new BufferedReader(new FileReader(file));
		String host = br.readLine();
		new UDPServer(host).start();
	    }
	}catch(Exception e){e.printStackTrace();}
    }
}
