package dimi.exception;

import java.io.Serializable;

/**
 * Raiz de todas as excecoes do servico.
 * @author mcmoraes
 */
public abstract class DimiException extends Exception implements Serializable{
    
    /**
     * Creates a new instance of <code>DimiException</code> without detail message.
     */
    public DimiException() {
    }
    
    
    /**
     * Constructs an instance of <code>DimiException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public DimiException(String msg) {
        super(msg);
    }

    /**
     * Constructs an instance of <code>DimiException</code> with the specified cause.
     * @param cause the cause
     */
    public DimiException(Throwable cause) {
        super(cause);
    }

}
