/*
 * DiscovererTester.java
 *
 * Created on 29 de Julho de 2004, 15:41
 */

package org.isam.exehda.services.perdis;

import org.isam.exehda.services.Logger;
import org.isam.exehda.Exehda;
import org.isam.util.xml.XmlElement;
import java.util.Vector;
import org.isam.exehda.services.CellInformationBase;
import org.isam.exehda.services.CellInformationBase.ResourceName;
import org.isam.exehda.services.CellInformationBase.NameSpace;


/**
 *
 * @author  guilherme
 */
public class DiscovererTester {
    
    
    public CellInformationBase cellInformationBase;
    public static boolean setNeighbors = true;
    /** 
     * Creates a new instance of DiscovererTester 
     */
    public DiscovererTester() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {

        Logger logger = ((Logger) Exehda.getService("logger"));
        
        UserComponent uc = new UserComponent();
        QueryBuilder qb = new QueryBuilder("Host",1, 0, 10000);
        qb.addGreaterCriteria("cpuMhz", "100");
        logger.log(Logger.Sev.DEBUG,"DiscovererTester","main","###### Query = " + qb.toString(), null);
        
        XmlElement results = uc.requestResource(qb);
        logger.log(Logger.Sev.DEBUG,"DiscovererTester","main","###### Results = " + results.toString(), null);
        
        //PreferenceManager prefManager = new PreferenceManager();
        //prefManager.setOrderBy("Host", "cpuMhz", "desc");
        //prefManager.setDefaultSelection(results, "libertines:2:8f360ce1:curly.inf.ufrgs.br");
        
        
        //XmlElement xmlPrefs = setOrderBy(null, "Host", "cpuMhz", "asc");
        //System.out.println("***** ORDERBY DEPOIS *****");
        //System.out.println(xmlPrefs.toString());
        
        //xmlPrefs = setOrderBy(xmlPrefs, "PDA", "memoryRam", "desc");
        //System.out.println("***** ORDERBY DEPOIS *****");
        //System.out.println(xmlPrefs.toString());
        
        //xmlPrefs = setOrderBy(xmlPrefs, "Host", "cpuMhz", "desc");
        //System.out.println("***** ORDERBY DEPOIS *****");
        //System.out.println(xmlPrefs.toString());
        
        //boolean isQuery = true;
        
        
        /*
        XmlElement xml1 = XmlElement.createDocRoot();
        xml1 = XmlElement.createElement("QUERYRESULT");
        
        XmlElement xmlRsc1 = XmlElement.createElement("RESOURCE");
        XmlElement xmlRsc2 = XmlElement.createElement("RESOURCE");
        XmlElement xmlRsc3 = XmlElement.createElement("RESOURCE");
        
        XmlElement xmlType1 = XmlElement.createElement("TYPE");
        XmlElement xmlType2 = XmlElement.createElement("TYPE");
        XmlElement xmlType3 = XmlElement.createElement("TYPE");
        
        XmlElement xmlTypeData1 = XmlElement.createPCData("HOST");
        XmlElement xmlTypeData2 = XmlElement.createPCData("HOST");
        XmlElement xmlTypeData3 = XmlElement.createPCData("HOST");
        
        XmlElement xmlName1 = XmlElement.createElement("NAME");
        XmlElement xmlName2 = XmlElement.createElement("NAME");
        XmlElement xmlName3 = XmlElement.createElement("NAME");
        
        XmlElement xmlNameData1 = XmlElement.createPCData("PC1");
        XmlElement xmlNameData2 = XmlElement.createPCData("PC2");
        XmlElement xmlNameData3 = XmlElement.createPCData("PC3");
                    
        XmlElement xmlProps1 = XmlElement.createElement("PROPERTIES");
        XmlElement xmlProps2 = XmlElement.createElement("PROPERTIES");
        XmlElement xmlProps3 = XmlElement.createElement("PROPERTIES");
        
        XmlElement xmlProp1 = XmlElement.createElement("PROPERTY");
        XmlElement xmlProp2 = XmlElement.createElement("PROPERTY");
        XmlElement xmlProp3 = XmlElement.createElement("PROPERTY");
        
        xmlProp1.setAttribute("name", "cpuMhz");
        xmlProp1.setAttribute("value", "a4000");
        
        xmlProp2.setAttribute("name", "cpuMhz");
        xmlProp2.setAttribute("value", "d100");
        
        xmlProp3.setAttribute("name", "cpuMhz");
        xmlProp3.setAttribute("value", "c500");
        
        xmlProps1.addChild(xmlProp1);
        xmlProps2.addChild(xmlProp2);
        xmlProps3.addChild(xmlProp3);
        
        xmlName1.addChild(xmlNameData1);
        xmlName2.addChild(xmlNameData2);
        xmlName3.addChild(xmlNameData3);   
        
        xmlType1.addChild(xmlTypeData1);
        xmlType2.addChild(xmlTypeData2);
        xmlType3.addChild(xmlTypeData3);   
        
        xmlRsc1.addChild(xmlName1);
        xmlRsc2.addChild(xmlName2);
        xmlRsc3.addChild(xmlName3);
        
        xmlRsc1.addChild(xmlType1);
        xmlRsc2.addChild(xmlType2);
        xmlRsc3.addChild(xmlType3);
        
        xmlRsc1.addChild(xmlProps1);
        xmlRsc2.addChild(xmlProps2);
        xmlRsc3.addChild(xmlProps3);
        
        xml1.addChild(xmlRsc1);
        xml1.addChild(xmlRsc2);        
        xml1.addChild(xmlRsc3);        
        
        System.out.println(xml1.toString()+"\n");
        */
        
        //System.out.println("****** FAZENDO SORT *******");
        //xml1 = sortResults(xml1, "Host");
        //System.out.println(xml1.toString()+"\n");
        
        //System.out.println("****** FAZENDO NARROW *******");
        //xml1 = narrowResults(xml1, 4);
        //System.out.println(xml1.toString()+"\n");

        //xmlPrefs = setDefaultSelection(xmlPrefs, xml1, "PC1");
        //System.out.println(" SET DEFAULT SELECTION - DEPOIS");
        //System.out.println(xmlPrefs.toString());
        
        //System.out.println(xml1.toString()+"\n");
        
        //xmlPrefs = setDefaultSelection(xmlPrefs, xml1, "PC3");
        //System.out.println(" SET DEFAULT SELECTION - DEPOIS 2");
        //System.out.println(xmlPrefs.toString());
        
        //xml1 = applyDefaultSelection(xmlPrefs, xml1);
        //System.out.println(" APPLY DEFAULT SELECTION - DEPOIS");
        //System.out.println(xml1.toString()+"\n");
        
        /*  
        if (isQuery) {

            UserComponent uc = new UserComponent();
            QueryBuilder qb = new QueryBuilder();
            qb.addMainAttributes("Host",3);
            qb.addGreaterCriteria("freeHdGB", "1");
            String[] val = {"Windows","Linux"};
            qb.addMultiValueCriteria("osName",val);
            qb.addRangeCriteria("usbPort", "1", "20");
            qb.addLessCriteria("memoryRamMb", "4096");

            QueryBuilder son1 = qb.addNewBranch();

            son1.addGreaterCriteria("freeHdGB", "12");
            son1.addInequalityCriteria("cpuMhz", "2500");

            QueryBuilder son2 = qb.addNewBranch();
            String[] values ={"2000","2200","2400","3000"};

            son2.addMultiValueCriteria("cpuMhz", values);
            son2.addRangeCriteria("freeHdGB", "20","49");

            logger.log(Logger.Sev.DEBUG,"DiscovererTester","main","###### Query = " + qb.toString(), null);

            long initialTime = System.currentTimeMillis();
            XmlElement results = uc.requestResource(qb);
            long finalTime = System.currentTimeMillis();

            long deltaTime = finalTime - initialTime;            
            logger.log(Logger.Sev.DEBUG,"DiscovererTester","main","\n################# Search done in = " + deltaTime + " ms\n###############\n", null);
            Thread.sleep(8000);
            logger.log(Logger.Sev.DEBUG,"DiscovererTester","main","###### Results = " + results.toString(), null);

        } else {
            Vector recursos = new Vector();
            for (int i = 1;i<=24;i++){
                long initialTime1 = System.currentTimeMillis();

                recursos.add(new ResourceComponent("/home/guilherme/resourcediscovery/testes/resource-descriptor-"+i+".xml"));
                long finalTime1 = System.currentTimeMillis();

                long deltaTime1 = finalTime1 - initialTime1;

                logger.log(Logger.Sev.DEBUG,"DiscovererTester","main","\n@@@@@@@@@@@\n###### Register done in = " + deltaTime1 + " ms\n##########\n@@@@@@@@", null);

            }

            for (int i =0; i< recursos.size();i++){
                long initialTime2 = System.currentTimeMillis();
                ((ResourceComponent) recursos.lastElement()).removeResource();
                long finalTime2 = System.currentTimeMillis();

                long deltaTime2 = finalTime2 - initialTime2;
                logger.log(Logger.Sev.DEBUG,"DiscovererTester","main","\n################\n###### Remove done in = " + deltaTime2 + " ms\n####################\n", null);
                Thread.sleep(2000);
                recursos.add(new ResourceComponent("/home/guilherme/resourcediscovery/testes/resource-descriptor-25.xml"));
                //recursos.remove(i);
            }
        }
        */
    }
    
    /** 
     *  setOrderBy
     */
    public static XmlElement setOrderBy(XmlElement xmlPrefs, String type, String attribute, String order) {
    
        //XmlElement xmlPrefs = this.readFileFromAVU();
        //if (xmlPrefs == null) {
        //    return;
        //}
        
        if (xmlPrefs == null) {
            XmlElement xmlDocRoot = XmlElement.createDocRoot();

            XmlElement xmlPreferencesA = XmlElement.createElement("PREFERENCES");
            XmlElement xmlResultSetsA = XmlElement.createElement("RESULTSETS");
            XmlElement xmlOrderByA = XmlElement.createElement("ORDERBY");

            xmlPreferencesA.addChild(xmlResultSetsA);
            xmlPreferencesA.addChild(xmlOrderByA);
            xmlDocRoot.addChild(xmlPreferencesA);

            xmlPrefs = xmlDocRoot;
        } 
        System.out.println("**** ORDERBY ANTES ****");
        System.out.println(xmlPrefs.toString() + "\n");

        
        
        boolean found = false;
        Vector vecOrder = XmlElement.selectByPath(xmlPrefs, "/PREFERENCES/ORDERBY/ORDER", null);
        
        for (int i = 0; i < vecOrder.size(); i++) {

            XmlElement xmlOrder = (XmlElement) vecOrder.get(i);
            String resourceTypeTmp = xmlOrder.getAttribute("resourceType", "");

            if (type.equalsIgnoreCase(resourceTypeTmp)) {                    
                
                found = true;
                xmlOrder.setAttribute("property", attribute);
                xmlOrder.setAttribute("orderType", order);
                break;
            }
        }
        
        if (!found) {
            Vector vecOrderBy = XmlElement.selectByPath(xmlPrefs, "/PREFERENCES/ORDERBY", null);
            XmlElement xmlOrderBy = (XmlElement) vecOrderBy.firstElement();
            
            XmlElement xmlOrder = XmlElement.createElement("ORDER");
            xmlOrder.setAttribute("resourceType", type);
            xmlOrder.setAttribute("property", attribute);
            xmlOrder.setAttribute("orderType", order);
                
            xmlOrderBy.addChild(xmlOrder);
        }
        
        //this.writeFileToAVU(xmlPrefs);
        return xmlPrefs;
    }
    
    /**
     * sortResults
     */
    public static XmlElement sortResults(XmlElement xmlResults, String type) {
    
        //Vector orderBy = this.getOrderBy(type);
        //if (orderBy == null) {
        //    return xmlResults;
        //}
        
        //String attribute = (String) orderBy.get(0);
        //String order = (String) orderBy.get(1);
        
        String attribute = "cpuMhz";
        String order = "desc";
                
        Vector vecSrc = XmlElement.selectByPath(xmlResults,"/RESOURCE",null);
        Vector newVecSrc = new Vector();

        for (int i = 0; i < vecSrc.size(); i++){
            
            //Get the value of the order attribute for one resource
            XmlElement xmlResource = (XmlElement) vecSrc.elementAt(i);
            Vector propsVec = XmlElement.selectByPath(xmlResource, "/PROPERTIES/PROPERTY", null);
            String strValueTmp = null;
            
            for (int j = 0; j < propsVec.size(); j++) {
            
                XmlElement xmlPropTmp = (XmlElement) propsVec.elementAt(j);
                String strPropTmp = xmlPropTmp.getAttribute("name","");
                
                if (strPropTmp.equalsIgnoreCase(attribute)) {
                    strValueTmp = xmlPropTmp.getAttribute("value","");
                    break;
                }
            }
            
            //Insert the resource in the right place at the new vector
            boolean found = false;
            
            if (strValueTmp != null) {
                
                for (int k = 0; k < newVecSrc.size(); k++) {
                
                    //Get the value of the order attribute for another resource
                    XmlElement xmlResource2 = (XmlElement) newVecSrc.elementAt(k);
                    Vector propsVec2 = XmlElement.selectByPath(xmlResource2, "/PROPERTIES/PROPERTY", null);
                    String strValueTmp2 = null;
            
                    for (int m = 0; m < propsVec2.size(); m++) {
            
                        XmlElement xmlPropTmp2 = (XmlElement) propsVec2.elementAt(m);
                        String strPropTmp2 = xmlPropTmp2.getAttribute("name","");
                
                        if (strPropTmp2.equalsIgnoreCase(attribute)) {
                            strValueTmp2 = xmlPropTmp2.getAttribute("value","");
                            break;
                        }
                    }
                
                    //aqui
                    if (strValueTmp2 == null) {
                        newVecSrc.add(k, xmlResource);
                        found = true;
                        break;
                    } else {
                        
                        int comp = 0;
                        
                        try {
                            comp = new Long(strValueTmp).compareTo(new Long(strValueTmp2));
                        } catch (NumberFormatException nfe) {
                            comp = strValueTmp.compareTo(strValueTmp2);
                        }
                        
                        if (order.equalsIgnoreCase("desc")) {
                            if (comp >= 0) {
                                newVecSrc.add(k, xmlResource);
                                found = true;
                                break;    
                            }
                        } else {
                            if (comp <= 0) {
                                newVecSrc.add(k, xmlResource);
                                found = true;
                                break;    
                            }
                        }
                    }
                }
            }
            
            if (!found) {
                newVecSrc.add(xmlResource);
            }
        }
        
        XmlElement newXmlResults = XmlElement.createDocRoot();
        newXmlResults = XmlElement.createElement("QUERYRESULT");
        
        for (int i = 0; i < newVecSrc.size(); i++) {
            newXmlResults.addChild((XmlElement) newVecSrc.elementAt(i));
        }
        
        return newXmlResults;
    }
    
    /**
     * narrowResults
     */
    public static XmlElement narrowResults(XmlElement xmlResults, int maxResults) {
    
        Vector vecSrc = XmlElement.selectByPath(xmlResults,"/RESOURCE",null);
        
        if (vecSrc.size() <= maxResults) {
            return xmlResults;
        }
        
        //Build the new QueryResult
        XmlElement newXmlResults = XmlElement.createDocRoot();
        newXmlResults = XmlElement.createElement("QUERYRESULT");
        
        for (int i = 0; i < maxResults; i++) {
            newXmlResults.addChild((XmlElement) vecSrc.elementAt(i));
        }
        
        return newXmlResults;
    }
    
    
    /**
     * setDefaultSelection
     */
    public static XmlElement setDefaultSelection(XmlElement xmlPrefs, XmlElement xmlResults, String defaultName) {
    
        //XmlElement xmlPrefs = this.readFileFromAVU();
        //if (xmlPrefs == null) {
        //    return;
        //}
        
        String resourceType = getTypeFromResults(xmlResults);

        boolean found = false;
        Vector vecResultSet = XmlElement.selectByPath(xmlPrefs, "/PREFERENCES/RESULTSETS/RESULTSET", null);
        
        for (int i = 0; i < vecResultSet.size(); i++) {

            XmlElement xmlResultSet = (XmlElement) vecResultSet.get(i);
            String resourceTypeTmp = xmlResultSet.getAttribute("resourceType", "");
            
            if (resourceType.equalsIgnoreCase(resourceTypeTmp)) {
                
                found = true;                
                
                xmlResultSet.clearContents();
                xmlResultSet.setAttribute("resourceType", resourceTypeTmp);
                
                Vector resourceNamesFromResults = getResourceNamesFromResults(xmlResults);
                for (int j = 0; j < resourceNamesFromResults.size(); j++) {
                    
                    String resourceName = (String) resourceNamesFromResults.get(j);
                    XmlElement xmlResource = XmlElement.createElement("RESOURCE");
                    xmlResource.setAttribute("name", resourceName);
                    
                    if (defaultName.equalsIgnoreCase(resourceName)) {
                        xmlResource.setAttribute("default", "yes");
                    }
                    
                    xmlResultSet.addChild(xmlResource);
                }
                
                break;
            }
        }
        
        if (!found) {

            Vector vecResultSets = XmlElement.selectByPath(xmlPrefs, "/PREFERENCES/RESULTSETS", null);
            XmlElement xmlResultSets = (XmlElement) vecResultSets.firstElement();
            
            XmlElement xmlResultSet = XmlElement.createElement("RESULTSET");
            xmlResultSet.setAttribute("resourceType", resourceType);
                
            Vector resourceNamesFromResults = getResourceNamesFromResults(xmlResults);
            for (int j = 0; j < resourceNamesFromResults.size(); j++) {

                String resourceName = (String) resourceNamesFromResults.get(j);
                XmlElement xmlResource = XmlElement.createElement("RESOURCE");
                xmlResource.setAttribute("name", resourceName);

                if (defaultName.equalsIgnoreCase(resourceName)) {
                    xmlResource.setAttribute("default", "yes");
                }
                
                xmlResultSet.addChild(xmlResource);
            }
            xmlResultSets.addChild(xmlResultSet);
        }
        
        //this.writeFileToAVU(xmlPrefs);
        return xmlPrefs;
    }
    
    /**
     * getResourceNamesFromResults
     */
    private static Vector getResourceNamesFromResults(XmlElement xmlResults) {
    
        Vector resourceNamesList = new Vector();
        
        Vector vecName = XmlElement.selectByPath(xmlResults, "/RESOURCE/NAME", null);
        for (int i = 0; i < vecName.size(); i++) {
            
            XmlElement xmlName = (XmlElement) vecName.elementAt(i);
            resourceNamesList.add(xmlName.getContents());
        }
        
        return resourceNamesList;
    }
    
    /**
     * getTypeFromResults
     */
    private static String getTypeFromResults(XmlElement xmlResults) {
    
        String resourceType = null;
        Vector vecType = XmlElement.selectByPath(xmlResults, "/RESOURCE/TYPE", null);
        
        if (vecType.size() > 0) {
            XmlElement xmlType = (XmlElement) vecType.firstElement();
            resourceType = (String) xmlType.getContents();
        }

        return resourceType;
    }
    
    /**
     * getResourceNamesFromPreferences
     */
    private static Vector getResourceNamesFromPreferences(XmlElement xmlPrefs, String resourceType) {
    
        Vector resourceNamesList = new Vector();
        
        Vector vecResultSet = XmlElement.selectByPath(xmlPrefs, "/PREFERENCES/RESULTSETS/RESULTSET", null);
        for (int i = 0; i < vecResultSet.size(); i++) {
            
            XmlElement xmlResultSet = (XmlElement) vecResultSet.elementAt(i);
            String resourceTypeTmp = xmlResultSet.getAttribute("resourceType", "");
            
            if (!resourceTypeTmp.equalsIgnoreCase(resourceType)) {

                continue;
            } else {
                
                Vector vecResource = XmlElement.selectByPath(xmlResultSet, "/RESOURCE", null);                
                for (int j = 0; j < vecResource.size(); j++) {
                
                    XmlElement xmlResource = (XmlElement) vecResource.get(j);
                    String resourceDefault = xmlResource.getAttribute("default", "");
                    String resourceName = xmlResource.getAttribute("name", "");
                    
                    //The default option is put at first
                    if (resourceDefault.equalsIgnoreCase("yes")) {
                        resourceNamesList.add(0, resourceName);
                    } else {
                        resourceNamesList.add(resourceName);
                    }   
                }
            }
        }
        
        return resourceNamesList;
    }
    
    /**
     * applyDefaultSelection
     */
    public static XmlElement applyDefaultSelection(XmlElement xmlPrefs, XmlElement xmlResults) {
        
        String defaultResource = getDefaultSelection(xmlPrefs, xmlResults);
        if (defaultResource != null) {
 
System.out.println("defaultResource = " + defaultResource);
            
            Vector vecResource = XmlElement.selectByPath(xmlResults,"/RESOURCE",null);
            XmlElement xmlResource = null;
            
            for (int i = 0; i < vecResource.size(); i++) {
                
                xmlResource = (XmlElement) vecResource.get(i);
                
                Vector vecName = XmlElement.selectByPath(xmlResource,"/NAME",null);
                XmlElement xmlName = (XmlElement) vecName.firstElement();
                String nameStr = (String) xmlName.getContents();
                
                if (nameStr.equalsIgnoreCase(defaultResource)) {
                    break;
                }
            }
                
            XmlElement newXmlResults = XmlElement.createDocRoot();
            newXmlResults = XmlElement.createElement("QUERYRESULT");    
            newXmlResults.addChild(xmlResource);
                
            return newXmlResults;                
        } else {
            return xmlResults;
        }
    }
    
    /** 
     *  getDefaultSelection
     */
    private static String getDefaultSelection(XmlElement xmlPrefs, XmlElement xmlResults) {
    
        //XmlElement xmlPrefs = this.readFileFromAVU();
        //if (xmlPrefs == null) {
        //    return null;
        //}
        
        Vector resourceNamesFromResults = getResourceNamesFromResults(xmlResults);
        Vector resourceNamesFromPreferences = getResourceNamesFromPreferences(xmlPrefs, getTypeFromResults(xmlResults));
        
        if ((resourceNamesFromResults.size() > 0) 
         && (resourceNamesFromPreferences.size() > 0)) {
        
            String defaultResource = (String) resourceNamesFromPreferences.firstElement();
        
            if (resourceNamesFromPreferences.containsAll(resourceNamesFromResults) 
             && resourceNamesFromResults.contains(defaultResource)) {
            
                 return defaultResource;
            } else {
                return null;
            }
        } else {
            return null;
        }
    }
}
