/*
 * UserComponent.java
 *
 * Created on 20 de Maio de 2004, 14:11
 */

package org.isam.exehda.services.perdis;

import org.isam.exehda.services.DiscovererService;
import org.isam.exehda.Exehda;
import org.isam.exehda.services.CellInformationBase;
import org.isam.exehda.services.CellInformationBase.ResourceName;
import org.isam.exehda.services.Logger;
import org.isam.util.xml.XmlElement;
import java.io.IOException;


/**
 *
 * @author  egon
 */
public class UserComponent {
    
    private DiscovererService discoverer;
    
    /** 
     * Creates a new instance of UserComponent 
     */
    public UserComponent() {
        
        this.discoverer = (DiscovererService) Exehda.getService(DiscovererService.SERVICE_NAME);
    }
    
    /**
     * requestResource
     */   
    public XmlElement requestResource(QueryBuilder queryBuilder) throws Exception {
        
        return discoverer.requestResource(queryBuilder.toXmlElement());
    }
    
    /**
     * main
     */
    public static void main(String [] args) throws Exception {
    
        Logger logger = ((Logger) Exehda.getService(Logger.SERVICE_NAME));
    }
}