
package exehda.mw;

/**
 *  Adaptation criteria
 * 
 */
public abstract class TimeGoalCriteria
    implements JobCriteria 
{
    long timeGoal = 0;

        /** 
         * Sets the time goal
         * 
         * @param timeGoalmillis 
         */
    public void
    setTimeGoal( long timeGoalmillis)
        {
            this.timeGoal= timeGoalmillis;
        }

        /** 
         * Sub-classes must implement a specific time aproximation technique
         * 
         * @param currJob 
         * @param elapsedtime 
         * @param timeGoal 
         * 
         * @return 
         */
    abstract public Object
    guessNewJobSize(Job currJob, long elapsedtime, long timeGoal);
}
