package exehda.mw;


import org.isam.exehda.Exehda;
import org.isam.exehda.HostId;
import org.isam.exehda.ApplicationId;
import org.isam.exehda.services.Executor;
import org.isam.exehda.ObjectId;
import org.isam.exehda.services.ObjectSeed.Activator;
// import org.isam.exehda.services.primos.objseed.*;
import org.isam.exehda.services.ObjectSeed.MarshaledOX;


/**
 * 
 * 
 */
public class WorkerCreator{


     public static class AnActivator
        implements Activator
    {
        public void activate( ObjectId oxID, Object obj, MarshaledOX extState )
            {
                System.out.println("Activating "+obj);
                thr = new Thread( (JobWorker) obj );
                thr.start();
            }

        public void deactivate( ObjectId oxID, Object obj, MarshaledOX oxState ) throws InterruptedException
            {
                System.out.println("\n\n\n\n\nDeactivating "+obj+"\n\n\n\n\n\n\n");
                thr.interrupt();
                thr.join();
                thr = null;
            }

        private transient Thread thr;
    }

    public WorkerCreator(){
    }

    public void createWorkers(int numWorkers, String masterContactAddress, String jobCriteria){
	
	Executor ex = (Executor) Exehda.getService("executor");

        
	
	Object[] params = new Object[2];
	params[0] = masterContactAddress;
	params[1] = jobCriteria;
        
	//Activator act = new ThreadActivator();

	for(int i=0; i < numWorkers; i++){
	    ex.createObject(JobWorker.class,params,new AnActivator(),null);
	}
    }
	

}
