// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.HostId;
import org.isam.exehda.ApplicationId;

public interface CellInformationBase
{   
    void addHost(HostId h, String contactAddr);
    void removeHost(HostId h);
    String getHostAttribute(HostId h, String attrName);
    void setHostAttribute(HostId h, String attrName, String attrValue);

    void addApplication(ApplicationId app, String codeBase);
    String getAppAttribute(ApplicationId app, String attrName);
//     void findHost();
//     void getCellAttribute();
//     void getSegmentAttribute();
//     void registerHost();
//     void unregisterHost();
//     void getHostAttribute();
//     void setHostAttribute();
//     void addSensor();
//     void removeSensor();
//     void setSensorAttribute();
//     void setSensorParameter();
//     void registerApplication();
//     void registerWorkerForApplication();
//     void findApplication();
}
