/*
 * DiscovererService.java
 *
 * Created on 25 de Maio de 2004, 16:44
 */

package org.isam.exehda.services;

import org.isam.util.xml.XmlElement;
import org.isam.exehda.services.CellInformationBase;
import org.isam.exehda.services.CellInformationBase.ResourceName;
import java.io.IOException;
import java.net.UnknownHostException;

/**
 *
 * @author  egon
 */
public interface DiscovererService {
    
    final static String SERVICE_NAME = "discoverer";
    
    public ResourceName registerResource(XmlElement xmlDescription) throws Exception;
    
    public void removeResource(ResourceName rn);
    
    public void renewResource(ResourceName rn, XmlElement xmlDescriptor, boolean isModified) throws Exception;
    
    public XmlElement requestResource(XmlElement xmlRequest) throws Exception;
}