/*
 * CibInstaller.java
 *
 * Created on December 1, 2004, 3:15 PM
 */

package org.isam.exehda.services.cib;

import java.util.*;
import javax.naming.*;
import javax.naming.directory.*;
import javax.naming.ldap.*;
import org.isam.exehda.*;
import org.isam.exehda.services.*;
import org.isam.exehda.services.CellInformationBase.ResourceName;
import org.isam.exehda.services.CellInformationBase.NameSpace;
import org.isam.exehda.services.CellInformationBase.SelectionConstraint;
import org.isam.exehda.services.CellInformationBase.AttributeDefinedConstraint;
import org.isam.exehda.services.CellInformationBase.SimpleRegexpConstraint;
import org.isam.exehda.services.CellInformationBase.CompositeSelectionConstraint;
import org.isam.exehda.services.cib.*;

/**
 *
 * @author  frainer
 */
public class CibInstaller {
    
    /** Creates a new instance of CibInstaller */
    public CibInstaller() {
    }
    
    public static void main(String[] args) {
        Ldap ldap = new Ldap("ldap://localhost","cn=Manager,dc=CELL","senha");
        ldap.createCell();
        ldap.disconnect();
        ldap.connect();
        Properties typeMap = new Properties();
        Properties attrMap = new Properties();
        ldap.setObject("cn=ResourceMap", typeMap);
        ldap.setObject("cn=AttributeMap",attrMap);
        ldap.disconnect();    
    }
    
}
