// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services.bda;

import org.isam.exehda.Exehda;
import org.isam.exehda.services.Service;

public class BdaImplClient
    implements Service
{
    final static String SERVICE_NAME = "bda";

    public BdaImplClient()
        {
        }
    
    public void
    start() throws Exception
        {
            String bdaHost = Exehda.getServiceProperty(SERVICE_NAME,
                                                       "bdaHost",
                                                       "localhost");
                // used by bda: protocol handler
            System.getProperties().put("isam.bdaHost", bdaHost);
        }

    public void
    stop() throws Exception
        {
        }
}
