/*
 * DiscovererTester.java
 *
 * Created on February 17, 2005, 12:11 PM
 */

package org.isam.exehda.services.discoverer;

import org.isam.exehda.Exehda;
import org.isam.exehda.services.Worb;


/**
 *
 * @author  frainer
 */
public class DiscovererTester {
    
    /** Creates a new instance of DiscovererTester */
    public DiscovererTester() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
    
        Exehda.bootstrap("teste-discoverer");
        
        Worb worb = (Worb) Exehda.getService(Worb.SERVICE_NAME);

        String discovererCellUri = Exehda.getServiceProperty(Discoverer.SERVICE_NAME,
                                                          Discoverer.PROP_DISCOVERER_URI,
                                                          "//localhost:1980/discoverer");

         Discoverer cellDiscoverer = (Discoverer) Exehda.getService(Discoverer.SERVICE_NAME);
               // worb.lookupService(discovererCellUri, Discoverer.class);
         
         ResourceDescriptor r = cellDiscoverer.register("<RESOURCE name=\"computer\" type=\"good_one\"><ATT name=\"my_name\" value=\"my_value\" /></RESOURCE>");
         r.setAttribute("my_name","new_one");
         cellDiscoverer.renew(r);
         //cellDiscoverer.remove(r);
         Query q = new Query("<RESOURCE scope=\"2\"><ATT name=\"my_name\" value=\"new_one\" /></RESOURCE>");
         ResourceDescriptor[] rds = cellDiscoverer.find(q);
         System.out.println("fjfhfhfhfh="+rds.length);
    }
    
}
