/*
 * MetaResourceDescriptor.java
 *
 * Created on February 15, 2005, 2:29 PM
 */

package org.isam.exehda.services.discoverer;

import java.util.*;

/**
 *
 * @author  frainer
 */
public class MetaResourceDescriptor {
    
    ResourceDescriptor rd;
    List attributes;
    
    /** Creates a new instance of MetaResourceDescriptor */
    public MetaResourceDescriptor(ResourceDescriptor rd, List attributes) {
        this.rd = rd;
        this.attributes = attributes;
    }
    
    /**
    * Recovers the ResourceDescriptor
    *
    * @return  a <code>ResourceDescriptor</code> 
    */   
    public ResourceDescriptor getResourceDescriptor(){
        return(rd);
    }
    
    
    /**
    * Recovers the attribute list
    *
    * @return  a <code>List</code> of <code>String</code> with the names of the resources attributes
    */   
    public List getAttributes(){
        return(attributes);
    }
    
    
}
