#!/bin/sh

#REMOTE INTERFACES
echo 'cp dimi/Disseminator.class ~/public_html/classes/dimi/'
cp dimi/Disseminator.class ~/public_html/classes/dimi/

echo 'cp dimi/Peer.class ~/public_html/classes/dimi/'
cp dimi/Peer.class ~/public_html/classes/dimi/

echo 'cp dimi/ProducerEntryPoint.class ~/public_html/classes/dimi/'
cp dimi/ProducerEntryPoint.class ~/public_html/classes/dimi/

echo 'cp dimi/ConsumerEntryPoint.class ~/public_html/classes/dimi/'
cp dimi/ConsumerEntryPoint.class ~/public_html/classes/dimi/

echo 'cp dimi/UserEntryPoint.class ~/public_html/classes/dimi/'
cp dimi/UserEntryPoint.class ~/public_html/classes/dimi/

echo 'cp dimi/DisseminationService.class ~/public_html/classes/dimi/'
cp dimi/DisseminationService.class ~/public_html/classes/dimi/

echo 'cp dimi/message/MessageListener.class ~/public_html/classes/dimi/message'
cp dimi/message/MessageListener.class ~/public_html/classes/dimi/message

#EXCEPTIONS
echo 'cp dimi/exception/*.class ~/public_html/classes/dimi/exception/'
cp dimi/exception/*.class ~/public_html/classes/dimi/exception/

#MESSAGES
echo 'cp dimi/message/*.class ~/public_html/classes/dimi/message/'
cp dimi/message/*.class ~/public_html/classes/dimi/message/

#CONFIGURATIONS
echo 'cp dimi/configuration/*.class ~/public_html/classes/dimi/configuration/'
cp dimi/configuration/*.class ~/public_html/classes/dimi/configuration/

#NAMES
echo 'cp dimi/name/*.class ~/public_html/classes/dimi/name/'
cp dimi/name/*.class ~/public_html/classes/dimi/name/

#DISSEMINATION_UNIT_IMPL
echo 'rmic -d . dimi.DisseminationUnitImpl'
rmic -d . dimi.DisseminationUnitImpl

echo 'cp dimi/DisseminationUnitImpl_*.class ~/public_html/classes/dimi/'
cp dimi/DisseminationUnitImpl_*.class ~/public_html/classes/dimi/

#CONSUMER_IMPL
echo 'rmic -d . dimi.ConsumerEntryPointImpl'
rmic -d . dimi.ConsumerEntryPointImpl

echo 'cp dimi/ConsumerEntryPointImpl_*.class ~/public_html/classes/dimi/'
cp dimi/ConsumerEntryPointImpl_*.class ~/public_html/classes/dimi/

#PRODUCER_IMPL
echo 'rmic -d . dimi.ProducerEntryPointImpl'
rmic -d . dimi.ProducerEntryPointImpl

echo 'cp dimi/ProducerEntryPointImpl_*.class ~/public_html/classes/dimi/'
cp dimi/ProducerEntryPointImpl_*.class ~/public_html/classes/dimi/

#MESSAGELISTENER_IMPL
echo 'rmic -d . dimi.message.MessageListenerImpl'
rmic -d . dimi.message.MessageListenerImpl

echo 'cp dimi/message/MessageListenerImpl_*.class ~/public_html/classes/dimi/message/'
cp dimi/message/MessageListenerImpl_*.class ~/public_html/classes/dimi/message/

echo 'Done.'