package dimi.message;

import java.io.Serializable;

/**
 * O conteudo de uma mensagem.
 * @author mcmoraes
 */
public class MessageContent implements Serializable{

    private byte[] data;
    
    /**
     * Creates a new instance of MessageContent
     * @param data os dados do conteudo da mensagem
     */
    public MessageContent(byte[] data) {
        this.data = data;
    }
    
    /**
     * Getter for property data.
     * @return Value of property data.
     */
    public byte[] getData() {
        return this.data;
    }
    
    /**
     * Setter for property data.
     * @param data New value of property data.
     */
    public void setData(byte[] data) {
        this.data = data;
    }
    
}
