package dimi.network;

import dimi.DBase;

/**
 * Medidor de distancia entre disseminadores.
 * @author mcmoraes
 */
public interface NetworkDistanceMeasurer {
    
    /**
     * Mede a distancia ate uma unidade de disseminacao
     * @return a distancia ate a referida unidade de disseminacao
     * @param dbase a unidade de disseminacao que se quer medir a distancia
     */    
    public long measureDistanceTo(DBase dbase);
    
}
