// Copyright 2002 Rodrigo Araujo Real
//		  Luciano Cavalheiro da Silva
//		  Iara Augustin
//		  Adenauer Correa Yamin
//                Gustavo Frainer
//		  Claudio Fernando Resin Geyer
//
// This file is part of TiPS. TiPS is a Probabilistic Scheduler
//
// TiPS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// TiPS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with TiPS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: TipsSchedulingHeuristic.java 284 2004-10-15 23:18:11Z rreal $
//

package org.isam.exehda.services.tips;

import org.isam.exehda.HostId;
import org.isam.exehda.ObjectId;
import org.isam.exehda.ApplicationId;
import org.isam.exehda.services.ObjectSeed.Activator;
import org.isam.exehda.services.ObjectSeed.ObjectHandle;
import org.isam.exehda.services.ResourceBroker.ResourceConstraint;
import org.isam.exehda.services.Executor;
import org.isam.exehda.services.Scheduler;
import org.isam.exehda.Exehda;
import java.util.Vector;


public class TipsSchedulingHeuristic
    implements Executor.SchedulingHeuristic
{

    Scheduler s;

    
    public HostId chooseCreationHost ( String cls, Object[] params, Object hint, Vector toAvoid ) 
        {
                //passando null para facilitar agora
            return(s.chooseCreationHost(null));
        }
    
  
    public HostId chooseMigrationHost ( ObjectHandle o, Object hint, Vector toAvoid )
        {
                //passando null para facilitar agora
            return(s.chooseMigrationHost(null));
        }

    public TipsSchedulingHeuristic() 
        {
            s = (Scheduler) Exehda.getService(Scheduler.SERVICE_NAME);
        }
    
}
