package org.isam.exehda.services.dhc.server;


import org.isam.exehda.services.dhc.*;
import java.net.*;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;


/*
 * ConfigServerRuner -- Runs the Config Server 
 */

public class ConfigServerRunner{

    public static void main(String[] args){
	String ipAddr = "" ;
	ConfigServerImpl server = new ConfigServerImpl();
	try {
	    UnicastRemoteObject.exportObject(server);
	    
	    // register the object within the nameservice        
	    Naming.rebind("Knoppix-ConfigServer", server);
	    
	    
	    try {
		InetAddress localhost = InetAddress.getLocalHost();
		ipAddr = localhost.getHostAddress();
	    }
	    catch (java.net.UnknownHostException uhe){
		uhe.printStackTrace();
	    }
	    
	    new UDPServer(ipAddr).start();
	}catch(Exception e){e.printStackTrace();}
	}
	
    }
    
