package dimi.message.buffer;

import dimi.message.Message;

/**
 * Interface do mediador vista pelo buffer de mensagens do disseminador.
 * @author mcmoraes
 */
public interface DisseminationUnitMessageBufferMediator extends MessageBufferMediator{
    
    /**
     * Remove a mensagem dos buffers de conexao.
     * @param message a mensagem a ser removida
     */    
    public void removeFromDisseminatorMessageBuffer(Message message);

}
