
import java.rmi.Naming;
import java.rmi.RemoteException;

public class StartExebot{

	public void startRoot (Task root,int timeOut){
  		Thread t=null;
		NodeManager nm=null;
		TaskEater te=null;
		ThiefVictimAgent tva=null;
		TaskManager tm = new TaskManager();

		try {
      	nm = new NodeManagerImpl();
      	Naming.rebind("rmi://localhost:1099/NodeManager", nm);
		}catch (RemoteException re) {
			System.out.println("Unable to create Node Manager: " + re);
			System.exit(0);
		}catch(java.net.MalformedURLException mfue){
			System.out.println("Unable to create Node Manager: " + mfue);
			System.exit(0);
		}
		try{
			tva = new ThiefVictimAgentImpl(tm,nm);
		}catch(RemoteException re){
			System.out.println("Unable to create ThiefVictimAgent: " + re);
			System.exit(0);
		}
		try{
			root.setID(0,Long.MAX_VALUE-1);
			te = new TaskEaterImpl(tm,tva,timeOut,root);
   		t = new Thread((TaskEaterImpl) te);
		}catch(RemoteException re){
			System.out.println("Unable to create TaskEater: " + re);
			System.exit(0);
		}
		try{
			nm.publishVictim(tva);
		}catch(RemoteException re){
			System.out.println("Unable to publish ThiefVictimAgent: " + re);
		}
		t.start();
		System.out.println("Task root starts ...");
	}

	public void startIdleNode(String NodeManagerHost,int timeOut){
		Thread t=null;
		NodeManager nm=null;
		TaskEater te=null;
		ThiefVictimAgent tva=null;
		TaskManager tm = new TaskManager();

		try {
            nm = (NodeManager) Naming.lookup("rmi://"+NodeManagerHost+":1099/NodeManager");

      }catch (RemoteException re) {
            System.out.println("Unable to find NodeManager: "+re);
            System.exit(0);
      }catch(java.rmi.NotBoundException nbe){
			System.out.println("Unable to find NodeManager: "+nbe);
         System.exit(0);
		}catch(java.net.MalformedURLException mfue){
			System.out.println("Unable to find NodeManager: "+mfue);
         System.exit(0);
		}
		try{
			tva = new ThiefVictimAgentImpl(tm,nm);
		}catch(RemoteException re){
			System.out.println("Unable to create ThiefVictimAgent: " + re);
			System.exit(0);
		}
		try{
			te = new TaskEaterImpl(tm,tva,timeOut);
			t = new Thread((TaskEaterImpl) te);
		}catch(RemoteException re){
			System.out.println("Unable to create TaskEater: " + re);
			System.exit(0);
		}
		try{
			nm.publishVictim(tva);
		}catch(RemoteException re){
			System.out.println("Unable to publish ThiefVictimAgent: " + re);
		}
		t.start();
		System.out.println("Idle node starts ...");
	}

}
