

public abstract class Task implements java.io.Serializable, Cloneable {

  /** Attributes */
  protected long myID;
  protected long fatherID;
  protected TaskEater father;
  protected long _sonsWorking;
  protected boolean _someActivated;
  protected long elapsedTime;
  protected long timeGoal;
  protected WorkCriteria wc;
  protected Object subParam;

  protected long base;
  protected long begin;
  protected long limit;
  protected long end;

  public static final long divisor = 100;

  abstract public void exec(Object param);

  abstract public void initTask ( Object param );

  abstract public Object getWork (Who who);

  abstract public void sendResults ( Object result, long who );

  abstract public void merge ();

  public abstract Object clone();

  public synchronized long sonsWorking (  ){
  	return _sonsWorking;
  }

  public synchronized boolean someActivated (  ){
  	return (_someActivated);
  }

  public synchronized void sonDone (  ){
  	_sonsWorking--;
  }

  public synchronized void sonActivated (  ){
  	_sonsWorking++;
	_someActivated=true;
  }

  public void run (  ){

  	Object obj = this.getWork(new Who(this.myID,this.elapsedTime,this.timeGoal,this.subParam)); //get a piece of work
  	while(obj != null){
		elapsedTime=0;
		subParam = obj; // to salve the last subParam not equal to null
		elapsedTime -= System.currentTimeMillis();
		this.exec(subParam);
		elapsedTime += System.currentTimeMillis();
		obj = this.getWork(new Who(this.myID,this.elapsedTime,this.timeGoal,this.subParam));
	}
  }

  public long getID(){
  	return(this.myID);
  }

	public void setID(long begin,long limit){
	//every task receive a interval of long values to identify its son
		this.myID = begin;
		this.begin = begin;
		this.limit = limit;
		base = (long) ((limit - begin + 1)/ divisor); // a task can have "divisor" sons with unique name
		end = base + begin;
  }

  public synchronized Interval getNewInterval(){
  		Interval inter = new Interval();

		inter.begin = this.begin+1;
		inter.limit = this.end;

		this.begin = end;
		this.end = this.end + base;

		return inter;
  }

  public Interval getInterval(){
  		Interval inter = new Interval();

		inter.begin = this.begin;
		inter.limit = this.limit;
		return inter;
  }

  public long getFatherID(){
  	return(this.fatherID);
  }

  public void setFatherID(long ID){
  	this.fatherID = ID;
  }

  public TaskEater getFather(){
  	return (this.father);
  }

  public void setFather(TaskEater te){
  	this.father = te;
  }

  public WorkCriteria getWorkCriteria(){
  		return this.wc;
  }

  public void setWorkCriteria(WorkCriteria wc){
  	this.wc = wc;
  }

  public long getTimeGoal(){
  	return(this.timeGoal);
  }

  public void setTimeGoal(long timeGoal){
  	this.timeGoal  = timeGoal;
  }

  public long getElapsedTime(){
  	return(this.elapsedTime);
  }

  public Object getParam(){
	return subParam;
  }

}
