

public class ThiefVictimAgentImpl extends java.rmi.server.UnicastRemoteObject implements ThiefVictimAgent{

private TaskManager tm;
private NodeManager nm;

public ThiefVictimAgentImpl(TaskManager tm,NodeManager nm) throws java.rmi.RemoteException{
	super();
	this.tm = tm;
	this.nm = nm;
}

//Thief part:
public Task stealTask(Who who) {
//find a victim and steal a task, if there is one
//"who" has the last TimeGoal, elapsedTime and param of the TaskEater caller

	try{  //try to find a victim
			ThiefVictimAgent victim;
			victim = nm.choseVictim(this);
			try{ //try to steal a task
				if (victim != null){
						Task t = victim.deliverTask(who);
					return t;
				}
				return null;
			}catch(java.rmi.RemoteException re){
				System.out.println("Error trying to steal a task");
				return null;
			}
	}catch(java.rmi.RemoteException re){
		System.out.println("Error trying to find a victim");
		return null;
	}
}

//Victim part:
public synchronized Task deliverTask(Who who) throws java.rmi.RemoteException{
//get a task, find work for it and deliver to thiefAgent
//"who" has the last TimeGoal, elapsedTime and param of the TaskEater caller

	Task t = tm.getTask(who);
	return t;
}

}
