package dimi.util.indexer;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Classe auxiliar para execucao de testes de disseminacao em uma mesma maquina.
 * Sua funcao e gerar numeros inteiros unicos para este indexador
 */
public interface Indexer extends Remote {
    /**
     * Obtem um inteiro unico dado por este indexador
     * @throws RemoteException indicate that either a communication failure or a protocol error has occurred
     * @return um inteiro unico dado por este indexador
     */    
    public long getNext() throws RemoteException;
}
