#!/bin/bash

appJarURL=$1
shift
serverName=$1
shift
schedCriteria=$1
shift

if [ -z "$appJarURL" ];
then
    echo $0": Missing application URL"
    exit -1
fi

if [ -z "$serverName" ];
then
    echo $0": Missing server address"
    exit -1
fi

if [ -z "$schedCriteria" ];
then
    echo $0": Missing scheduling criteria"
    exit -1
fi

./start_exec.sh java -cp spinash.jar Starter $appJarURL "//$serverName" $schedCriteria $*
