// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;



public interface Deflector
{
    public static final String SERVICE_NAME = "deflector";
    
    public static class ChannelId
    {
            /**
             * Describe <code>getKey</code> method here.
             *
             * @return an <code>Object</code> value
             */
        public Object getKey()
            {
                throw new NullPointerException("Not yet implemented.");
            }
  
            /**
             * Describe <code>getName</code> method here.
             *
             * @return a <code>String</code> value
             */
        public String getName()
            {
                throw new NullPointerException("Not yet implemented.");
            }
  
            /**
             * Creates a new <code>ChannelId</code> instance.
             *
             * @param k an <code>Object</code> value
             * @param n a <code>String</code> value
             */
        public ChannelId( Object k, String n )
            {
                throw new NullPointerException("Not yet implemented.");
            }
    }

    public static interface MulticastListener
    {
            /**
             * Describe <code>update</code> method here.
             *
             * @param ch a <code>ChannelId</code> value
             * @param timestamp a <code>long</code> value
             * @param data an <code>Object</code> value
             */
        public void update ( ChannelId ch, long timestamp, Object data );
    }
    
        /**
         * Describe <code>createChannel</code> method here.
         *
         * @param chName a <code>String</code> value
         * @return a <code>ChannelId</code> value
         */
    public ChannelId createChannel( String chName );
    
        /**
         * Describe <code>joinChannel</code> method here.
         *
         * @param chName a <code>String</code> value
         * @param l a <code>MulticastListener</code> value
         * @return a <code>ChannelId</code> value
         */
    public ChannelId joinChannel( String chName, MulticastListener l );

        /**
         * Describe <code>leaveChannel</code> method here.
         *
         * @param ch a <code>ChannelId</code> value
         * @param l a <code>MulticastListener</code> value
         */
    public void leaveChannel( ChannelId ch, MulticastListener l );
    
        /**
         * Describe <code>deliver</code> method here.
         *
         * @param ch a <code>ChannelId</code> value
         * @param timestamp a <code>long</code> value
         * @param data an <code>Object</code> value
         */
    public void deliver( ChannelId ch, long timestamp, Object data );
}

