package exehda.mw;


import org.isam.exehda.Exehda;
import org.isam.exehda.HostId;
import org.isam.exehda.ApplicationId;
import org.isam.exehda.services.Executor;
import org.isam.exehda.services.ObjectSeed.ObjectHandle;
import org.isam.exehda.services.ObjectSeed.Activator;


/**
 * 
 * 
 */
public class WorkerCreator{

    public WorkerCreator(){
    }

    public void createWorkers(int numWorkers, String masterContactAddress, String jobCriteria){
	
	Executor ex = (Executor) Exehda.getService("executor");

        ApplicationId aid = ex.currentApplication();
	
	Object[] params = new Object[2];
	params[0] = masterContactAddress;
	params[1] = jobCriteria;
        
	for(int i=0; i < numWorkers; i++){
	    ex.createObject(aid, JobWorker.class,params,null,null);
	}
    }
	

}
