// Copyright 2003 ISAM Team <http://www.inf.ufrgs.br/~isam/>
//
// This file is part of ISAM.
//
// ISAM is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// ISAM is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ISAM; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

package org.isam.exehda.services;

import org.isam.exehda.HostId;
import org.isam.exehda.ObjectId;
import org.isam.exehda.ApplicationId;
import org.isam.exehda.services.ObjectSeed.Activator;
import org.isam.exehda.services.ObjectSeed.ObjectHandle;
import java.util.Vector;




public interface Executor
{
    public static final String SERVICE_NAME = "executor";


//     public static interface Activator
//         extends java.io.Serializable
//     {
// //         public static Activator getDefaultInstance( Class type );
//         public abstract void activate( Object o );
//         public abstract void deactivate( Object o );
//     }

//     public static class ThreadActivator
//         implements Activator
//     {
//             /**
//              * Describe <code>getInstance</code> method here.
//              *
//              * @return an <code>Activator</code> value
//              */
//         public static Activator getInstance()
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
        
//             /**
//              * Creates a new <code>activate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void activate( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
            
//             /**
//              * Creates a new <code>deactivate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void deactivate( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//     }

//     public static class RMIActivator
//         implements Activator
//     {
//             /**
//              * Describe <code>getInstance</code> method here.
//              *
//              * @return an <code>Activator</code> value
//              */
//         public static Activator getInstance()
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
            
//             /**
//              * Creates a new <code>activate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void activate( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
            
//             /**
//              * Creates a new <code>deactivate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void deactivate ( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//     }
    
//     public static class ActivatableActivator
//         implements Activator
//     {
//             /**
//              * Describe <code>getInstance</code> method here.
//              *
//              * @return an <code>Activator</code> value
//              */
//         public static Activator getInstance()
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
            
//             /**
//              * Creates a new <code>activate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void activate( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//             /**
//              * Creates a new <code>deactivate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void deactivate( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//     }    


//     public static class CompositeActivator
//         implements Activator
//     {
//             /**
//              * Creates a new <code>CompositeActivator</code> instance.
//              *
//              */
//         public CompositeActivator()
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//             /**
//              * Describe <code>addActivator</code> method here.
//              *
//              * @param a an <code>Activator</code> value
//              */
//         public void addActivator ( Activator a )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//             /**
//              * Creates a new <code>activate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void activate ( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//             /**
//              * Creates a new <code>deactivate</code> instance.
//              *
//              * @param o an <code>Object</code> value
//              */
//         public void deactivate ( Object o )
//             {
//                 throw new NullPointerException("Not yet implemented");
//             }
//     }

//     public static interface Activatable
//     {
//             /**
//              * Describe <code>activate</code> method here.
//              *
//              */
//         public void activate();
        
//             /**
//              * Describe <code>deactivate</code> method here.
//              *
//              */
//         public void deactivate();
//     }

    public static interface Migrable
        extends java.io.Serializable
    {
            /**
             * Describe <code>captureState</code> method here.
             *
             * @param to a <code>java.io.ObjectOutput</code> value
             */
        public void captureState ( java.io.ObjectOutput to );
        
            /**
             * Describe <code>restoreState</code> method here.
             *
             * @param from a <code>java.io.ObjectInput</code> value
             */
        public void restoreState ( java.io.ObjectInput from );
    }

    public static class MarshaledOX
        //TODO:        implements java.io.Serializable,java.io.ObjectOutput,java.io.ObjectInput
    {
        public MarshaledOX (  )
            {
                throw new NullPointerException("Not yet implemented");
            }
        public void putAttribute ( String attr, Object val )
            {
                throw new NullPointerException("Not yet implemented");
            }
        public Object getAttribute ( String attr )
            {
                throw new NullPointerException("Not yet implemented");
            }
    }

    public static interface SchedulingHeuristic
        extends java.io.Serializable
    {
        public HostId chooseCreationHost ( String cls, Object[] params, Object hint, Vector toAvoid );
  
        public HostId chooseMigrationHost ( ObjectHandle o, Object hint, Vector toAvoid );
    }
    

        /**
         * Describe <code>createObject</code> method here.
         *
         * TODO: remove applicationId from parameters
         * TODO: change return type to ObjectId
         *
         * @param c a <code>Class</code> value
         * @param p an <code>Object[]</code> value
         * @param a an <code>Activator</code> value
         * @param hint an <code>Object</code> value
         * @return an <code>ObjectId</code> value
         */ 
    public ObjectHandle createObject( ApplicationId app, Class c, Object[] p, Activator a, Object hint );
    
        /**
         * Describe <code>moveObject</code> method here.
         *
         * @param ox an <code>ObjectId</code> value
         * @param placementHint an <code>Object</code> value
         */
    public void moveObject( ObjectId ox, Object placementHint );

        /**
         * Describe <code>deactivateObject</code> method here.
         *
         * @param ox an <code>ObjectId</code> value
         * @param oxState a <code>MarshaledOX</code> value
         */
    public void deactivateObject( ObjectId ox, MarshaledOX oxState );

        /**
         * Describe <code>activateObject</code> method here.
         *
         * @param oxState a <code>MarshaledOX</code> value
         */
    public void activateObject( MarshaledOX oxState );

        /**
         * Describe <code>startApplication</code> method here.
         *
         * TODO: change parameter type to String
         *
         * @param launchingDesc a <code>XmlDocument</code> value
         */
    public void startApplication( org.isam.util.xml.XmlElement launchingDesc );
    
        /**
         * Describe <code>exitApplication</code> method here.
         *
         */
    public void exitApplication();
    
        /**
         * Describe <code>currentApplication</code> method here.
         *
         * @return an <code>ApplicationId</code> value
         */
    public ApplicationId currentApplication();

        /**
         * Describe <code>runAction</code> method here.
         *
         * @param app an <code>ApplicationId</code> value
         * @param action a <code>Runnable</code> value
         */
    public void runAction(ApplicationId app, Runnable action);

        /**
         * This method is deprecated, avoid using it in new code.
         *
         * Sets the per-application scheduling heuristic. 
         *
         * @param sh a <code>SchedulingHeuristic</code> value
         * @deprecated As an application attribute, the sche-heuristic is going
         *             to be configured through the application launching descriptor,
         *             but this feature is not yet implemented.
         */
    public void setHeuristic( SchedulingHeuristic sh );
}

// OLD:
//
// public interface Executor
// {
//     public final String SERVICE_NAME = "executor";
    
//     public static interface SchedulingHeuristic
//     {
//         HostId chooseCreationHost(String clsName,
//                                   Object[] params,
//                                   Object hint,
//                                   java.util.Vector avoidedHosts)
//             throws VetoedOperationException;
    

// //         Object chooseMigrationHost(ObjectAddress obj,
// //                                    Object hint,
// //                                    java.util.Vector avoidedHosts)
// //             throws VetoedOperationException;
//     }

//     public static class VetoedOperationException
//         extends Exception
//     {
//         public 
//         VetoedOperationException( String msg )
//             {
//                 super(msg);
//             }
//     }
    
// //     public void
// //     createObject( Class c, Object[] params, Activator a, Object hint);

//     public ObjectHandle
//     createObject( ApplicationId app, Class c, Object[] params, Activator a, Object hint);

//     public void
//     startApplication(org.isam.util.xml.XmlElement launchDescriptor);

//     public void
//     runAction(ApplicationId app, Runnable action);
        
//     public ApplicationId
//     currentApplication();

// //     public void
// //     stopApplication();
    
// //     public ObjectHandle
// //     moveObject( ObjectHandle objHandle, Object hint);

// //     public ObjectHandle
// //     restoreObject( ObjectHandle objHandle, byte[] objectState, Activator a);

//     public void
//     setHeuristic( SchedulingHeuristic sh );
// }
