package dimi;

import dimi.Disseminator;

import java.rmi.RemoteException;

/**
 * Interface de um ponto de entrada de usuario.
 * @author mcmoraes
 */
public interface UserEntryPoint extends Disseminator{
    
    /**
     * Inutiliza este ponto de entrada. Se for de um produtor, destroi o canal. Se
     * for de um consumidor termina o consumo.
     * @throws RemoteException if failed to export object
     */    
    public void destroy() throws RemoteException;
    
}
