package dimi.example;

import dimi.message.MessageListenerImpl;
import dimi.message.Message;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.Serializable;
import java.io.PrintStream;

/**
 *
 * @author  mcmoraes
 */
public class SimpleMessageListener extends MessageListenerImpl{
    
    PrintStream printStream = null;
    
    public SimpleMessageListener(PrintStream printStream) throws RemoteException{
        super();
        this.printStream = printStream;
    }
    
    public void onMessage(Message message) throws RemoteException{
        printStream.println("Message Arrived : "+ message.getHeader().toString());
    }
    
}
