// Copyright 2002 Rodrigo Araujo Real
//		  Luciano Cavalheiro da Silva
//		  Iara Augustin
//		  Adenauer Correa Yamin
//                Gustavo Frainer
//		  Claudio Fernando Resin Geyer
//
// This file is part of TiPS.
//
// TiPS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// TiPS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with TiPS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Id: BayesNetworkData2.java 83 2003-12-17 18:04:29Z rreal $
//

/**
 * @file   BayesNetworkData2.java
 * @author Rodrigo Real
 * @date   Tue Nov 25 17:28:37 2003
 * 
 * @brief  Datatypes for Bayes Network 2
 * $Id: BayesNetworkData2.java 83 2003-12-17 18:04:29Z rreal $
 * 
 * 
 */


package org.isam.exehda.services.tips;

import java.util.*;

public class BayesNetworkData2
{

    private double values[];
    private double constancy;
    
    public BayesNetworkData2(double values[], double constancy) 
        {
            this.values = values;
            this.constancy = constancy;
        }

    public double getValuefor(int index) 
        {
            return(values[index]);
        }

    public double getConstancy() 
        {
            return(constancy);
        }
}
